#include "ExtendedBilateral.h"

void ExtendedBilateral::YUVToYUYV(PVideoFrame &dst)
{
	unsigned char *pDst = dst->GetWritePtr(), *it = fBuffer;
	int pitch = dst->GetPitch(), rowSize = dst->GetRowSize();

	for (int y = 0; y < height; y++, pDst += pitch, it += 3 * width)
		for (int x = 0, x1 = 0; x < 3 * width, x1 < rowSize; x += 6, x1 += 4)
		{
			pDst[x1] = it[x];
			pDst[x1 + 1] = (it[x + 1] + it[x + 4] + 1) >> 1;
			pDst[x1 + 2] = it[x + 3];
			pDst[x1 + 3] = (it[x + 2] + it[x + 5] + 1) >> 1;
		}
}

void ExtendedBilateral::YUYVToYUV(PVideoFrame &src)
{
	const unsigned char *pSrc = src->GetReadPtr();
	int pitch = src->GetPitch(), rowSize = src->GetRowSize();
	unsigned char *it = iBuffer;
	
	if (sup)
		for (int y = 0; y < height; y++, pSrc += pitch, it += 3 * width)
			for (int x = 0, x1 = 0; x < 3 * width, x1 < rowSize; x += 6, x1 += 4)
			{
				it[x] = pSrc[x1];
				it[x + 1] = it[x + 4] = pSrc[x1 + 1];
				it[x + 2] = it[x + 5] = pSrc[x1 + 3];
				it[x + 3] = pSrc[x1 + 2];
			}
	else
		for (int y = 0; y < height; y++, pSrc += pitch, it += 3 * width)
		{
			int x = 0, x1 = 0;

			while ((x < 3 * (width - 2)) && (x1 < rowSize - 4))
			{
				it[x] = pSrc[x1];
				it[x + 1] = pSrc[x1 + 1];
				it[x + 2] = pSrc[x1 + 3];

				it[x + 3] = pSrc[x1 + 2];
				it[x + 4] = (pSrc[x1 + 1] + pSrc[x1 + 5] + 1) >> 1;
				it[x + 5] = (pSrc[x1 + 3] + pSrc[x1 + 7] + 1) >> 1;

				x += 6;
				x1 += 4;
			}

			it[x] = pSrc[x1];
			it[x + 1] = it[x + 4] = pSrc[x1 + 1];
			it[x + 2] = it[x + 5] = pSrc[x1 + 3];
			it[x + 3] = pSrc[x1 + 2];
		}
}